<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.14"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Treap: Treap&lt; Key, Val, Cmp &gt;::TreapProxy Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Treap
   </div>
   <div id="projectbrief">Implementation of the treap data structure.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.14 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="classTreap.html">Treap</a></li><li class="navelem"><a class="el" href="classTreap_1_1TreapProxy.html">TreapProxy</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classTreap_1_1TreapProxy-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Treap&lt; Key, Val, Cmp &gt;::TreapProxy Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Proxy class for the overloaded operator[].  
 <a href="classTreap_1_1TreapProxy.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="Treap_8hpp_source.html">Treap.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a958c7c205a9fcd6853a6c555d316f62b"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTreap_1_1TreapProxy.html#a958c7c205a9fcd6853a6c555d316f62b">operator const Item *</a> () const</td></tr>
<tr class="memdesc:a958c7c205a9fcd6853a6c555d316f62b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Casting operator (getter).  <a href="#a958c7c205a9fcd6853a6c555d316f62b">More...</a><br /></td></tr>
<tr class="separator:a958c7c205a9fcd6853a6c555d316f62b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a19f23b60aeb0dc5bf76764ed42e109df"><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classTreap.html#a9c412706b67b278f58833ef254985c06">Item</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTreap_1_1TreapProxy.html#a19f23b60aeb0dc5bf76764ed42e109df">operator=</a> (const Val &amp;t_v)</td></tr>
<tr class="memdesc:a19f23b60aeb0dc5bf76764ed42e109df"><td class="mdescLeft">&#160;</td><td class="mdescRight">Assignment operator (setter).  <a href="#a19f23b60aeb0dc5bf76764ed42e109df">More...</a><br /></td></tr>
<tr class="separator:a19f23b60aeb0dc5bf76764ed42e109df"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename Key, typename Val, typename Cmp = std::less&lt;Key&gt;&gt;<br />
class Treap&lt; Key, Val, Cmp &gt;::TreapProxy</h3>

<p>Proxy class for the overloaded operator[]. </p>
<p>This class is used as a proxy for the original <a class="el" href="classTreap.html" title="Associative container. ">Treap</a> class in order to utilize the operator[] both as a getter and setter. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="a958c7c205a9fcd6853a6c555d316f62b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a958c7c205a9fcd6853a6c555d316f62b">&#9670;&nbsp;</a></span>operator const Item *()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename Key, typename Val, typename Cmp = std::less&lt;Key&gt;&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classTreap.html">Treap</a>&lt; Key, Val, Cmp &gt;::TreapProxy::operator const <a class="el" href="classTreap.html#a9c412706b67b278f58833ef254985c06">Item</a> * </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Casting operator (getter). </p>
<p>This operator is used as a getter for the original <a class="el" href="classTreap.html" title="Associative container. ">Treap</a> class. </p><dl class="section return"><dt>Returns</dt><dd>A pointer to an Item with the corresponding key, nullptr if there was no such Item. </dd></dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="classTreap.html#a6785715273eb84ba405f8e65629c380b" title="Search for an Item in the Treap. ">search()</a> </dd></dl>
<dl class="section user"><dt>Complexity</dt><dd>average: <img class="formulaInl" alt="$ O(\log n) $" src="form_0.png"/>, worst case: <img class="formulaInl" alt="$ O(n) $" src="form_1.png"/> </dd></dl>

</div>
</div>
<a id="a19f23b60aeb0dc5bf76764ed42e109df"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a19f23b60aeb0dc5bf76764ed42e109df">&#9670;&nbsp;</a></span>operator=()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename Key, typename Val, typename Cmp = std::less&lt;Key&gt;&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classTreap.html#a9c412706b67b278f58833ef254985c06">Item</a>* <a class="el" href="classTreap.html">Treap</a>&lt; Key, Val, Cmp &gt;::TreapProxy::operator= </td>
          <td>(</td>
          <td class="paramtype">const Val &amp;&#160;</td>
          <td class="paramname"><em>t_v</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Assignment operator (setter). </p>
<p>This operator is used as a setter for the original <a class="el" href="classTreap.html" title="Associative container. ">Treap</a> class. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">t_v</td><td>Value to be stored in the Item. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Pointer to the newly inserted Item or to an already existing updated Item. </dd></dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="classTreap.html#a982f1b1df8778e196190996080c219b0" title="Inserts or updates an Item in the Treap. ">insert()</a> </dd></dl>
<dl class="section user"><dt>Complexity</dt><dd>average: <img class="formulaInl" alt="$ O(\log n) $" src="form_0.png"/>, worst case: <img class="formulaInl" alt="$ O(n) $" src="form_1.png"/> </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/home/marek/projects/treap/incluce/<a class="el" href="Treap_8hpp_source.html">Treap.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.14
</small></address>
</body>
</html>
